#!/usr/bin/env node

// Generated by CoffeeScript 1.8.0
(function() {
  var Args, Canvas, Image, args, canvas, context, data, encode, flag, flags, flagsValues, height, image, output, quality, readFileSync, result, sampling, samplingValues, source, width, writeFileSync, _i, _len, _ref, _ref1, _ref2,
    __indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

  Args = require("arg-parser");

  encode = require("./index").encode;

  _ref = require("fs"), readFileSync = _ref.readFileSync, writeFileSync = _ref.writeFileSync;

  Canvas = require("canvas");

  Image = Canvas.Image;

  args = new Args("convert", "0.0.1", "mozjpeg image converter", "Convert images using mozjpeg");

  args.add({
    name: "source",
    desc: "source image",
    required: true
  });

  args.add({
    name: "output",
    desc: "output image",
    switches: ["-o", "--output"],
    value: "image"
  });

  args.add({
    name: "quality",
    desc: "jpeg quality (default: 70)",
    switches: ["-q", "--quality"],
    value: "percent"
  });

  args.add({
    name: "sampling",
    desc: "conversion sampling (default: 444)",
    switches: ["-s", "--sampling"],
    value: samplingValues = "444,422,420,gray,440,411"
  });

  args.add({
    name: "flags",
    desc: "coma-separated conversion flags (default: none)",
    switches: ["-f", "--flags"],
    value: flagsValues = "bottomup,fastupsample,fastdct,accuratedct"
  });

  if (!args.parse()) {
    return;
  }

  _ref1 = args.params, source = _ref1.source, output = _ref1.output, quality = _ref1.quality, sampling = _ref1.sampling, flags = _ref1.flags;

  if (output == null) {
    output = source;
  }

  if (quality == null) {
    quality = 70;
  }

  if (sampling == null) {
    sampling = "444";
  }

  if (flags == null) {
    flags = "";
  }

  quality = quality | 0;

  if (!((0 <= quality && quality <= 100))) {
    console.error("Invalid quality: " + quality + "! Please use decimal number in range 0...100");
    return;
  }

  if (__indexOf.call(samplingValues.split(","), sampling) < 0) {
    console.error("Invalid sampling: " + sampling + "! Please use one of " + samplingValues + ".");
    return;
  }

  _ref2 = flags.split(",");
  for (_i = 0, _len = _ref2.length; _i < _len; _i++) {
    flag = _ref2[_i];
    if (!(flag && __indexOf.call(flagsValues.split(","), flag) < 0)) {
      continue;
    }
    console.error("Invalid flag: " + flag + "! Please use any of " + flagsValues + ".");
    return;
  }

  sampling = sampling.toUpperCase();

  flags = flags.toUpperCase();

  canvas = new Canvas(100, 100);

  context = canvas.getContext("2d");

  image = new Image;

  image.src = readFileSync(source);

  width = image.width, height = image.height;

  canvas.width = width;

  canvas.height = height;

  context.drawImage(image, 0, 0, width, height);

  data = context.getImageData(0, 0, width, height).data;

  result = encode({
    data: data,
    width: width,
    height: height,
    quality: quality,
    sampling: sampling,
    flags: flags
  });

  writeFileSync(output, result);

}).call(this);
