// Generated by CoffeeScript 1.8.0
(function() {
  var HEAPU8, TJFLAG, TJPF, TJSAMP, cwrap, getFlags, getValue, i32, i8, setValue, tjCompress2, tjGetErrorStr, tjInitCompress, _free, _handle, _malloc, _ref;

  _ref = require("./libturbojpeg"), cwrap = _ref.cwrap, getValue = _ref.getValue, setValue = _ref.setValue, HEAPU8 = _ref.HEAPU8, _malloc = _ref._malloc, _free = _ref._free, i8 = _ref.i8, i32 = _ref.i32;

  TJPF = {
    RGB: 0,
    BGR: 1,
    RGBX: 2,
    BGRX: 3,
    XBGR: 4,
    XRGB: 5,
    GRAY: 6,
    RGBA: 7,
    BGRA: 8,
    ABGR: 9,
    ARGB: 10,
    CMYK: 11
  };

  TJSAMP = {
    444: 0,
    422: 1,
    420: 2,
    GRAY: 3,
    440: 4,
    411: 5
  };

  TJFLAG = {
    BOTTOMUP: 2,
    FASTUPSAMPLE: 256,
    NOREALLOC: 1024,
    FASTDCT: 2048,
    ACCURATEDCT: 4096
  };

  tjInitCompress = cwrap('tjInitCompress', 'number');

  tjCompress2 = cwrap('tjCompress2', 'number', ['number', 'array', 'number', 'number', 'number', 'number', 'number', 'number', 'number', 'number', 'number']);

  tjGetErrorStr = cwrap('tjGetErrorStr', 'string');

  getFlags = function(flags) {
    var flag, result, _i, _len;
    if (typeof flags === "string") {
      flags = flags.split(/[+,|]/);
    }
    result = 0;
    for (_i = 0, _len = flags.length; _i < _len; _i++) {
      flag = flags[_i];
      if (flag in TJFLAG) {
        result |= TJFLAG[flag];
      }
    }
    return result;
  };

  _handle = null;

  this.encode = function(_arg) {
    var data, dst_buf, dst_buf_len, dst_buf_ptr, dst_data, dst_len, flags, height, pixelFormat, quality, subSampling, width;
    data = _arg.data, width = _arg.width, height = _arg.height, quality = _arg.quality, pixelFormat = _arg.pixelFormat, subSampling = _arg.subSampling, flags = _arg.flags;
    if (_handle == null) {
      _handle = tjInitCompress();
    }
    if (quality == null) {
      quality = 100;
    }
    if (pixelFormat == null) {
      pixelFormat = "RGBA";
    }
    if (subSampling == null) {
      subSampling = "444";
    }
    flags = ["FASTDCT", "FASTUPSAMPLE"];
    dst_buf_ptr = _malloc(4);
    setValue(dst_buf_ptr, 0, i32);
    dst_buf_len = _malloc(4);
    setValue(dst_buf_len, 0, i32);
    if (0 !== tjCompress2(_handle, data, width, width * 4, height, TJPF[pixelFormat], dst_buf_ptr, dst_buf_len, TJSAMP[subSampling], quality, getFlags(flags))) {
      throw new Error(tjGetErrorStr());
    }
    dst_len = (new Uint32Array(HEAPU8.buffer, dst_buf_len))[0];
    dst_buf = (new Uint32Array(HEAPU8.buffer, dst_buf_ptr))[0];
    dst_data = new Buffer(new Uint8Array(HEAPU8.buffer, dst_buf, dst_len));
    _free(dst_buf_len);
    _free(dst_buf);
    _free(dst_buf_ptr);
    return dst_data;
  };

}).call(this);
